"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("../../package");
const Object_1 = require("../Object");
const Type_1 = require("../Type");
class KeyValuePair extends Object_1.default {
    constructor(key, value) {
        super();
        this._key = key;
        this._value = value;
    }
    get key() {
        return this._key;
    }
    get value() {
        return this._value;
    }
    equals(other) {
        return (other instanceof KeyValuePair
            && other._key.equals(this._key)
            && other._value.equals(this._value));
    }
    getType() {
        return new Type_1.default(this, package_1.default);
    }
}
exports.KeyValuePair = KeyValuePair;
exports.default = KeyValuePair;
