"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("../../package");
const Object_1 = require("../Object");
const RuntimeUtility_1 = require("../Runtime/RuntimeUtility");
const Type_1 = require("../Type");
class Event extends Object_1.default {
    constructor() {
        super();
        this._eventHandlers = {};
    }
    add(eventHandler) {
        if (!eventHandler.uniqueID) {
            eventHandler.uniqueID = RuntimeUtility_1.default.generateUniqueHashCode();
        }
        this._eventHandlers[eventHandler.uniqueID.toString(16)] = eventHandler;
        return eventHandler;
    }
    getType() {
        return new Type_1.default(this, package_1.default);
    }
    raise(sender, e) {
        global.Object.keys(this._eventHandlers).forEach((key) => {
            global.setTimeout(() => this._eventHandlers[key](sender, e), 1);
        });
    }
    remove(eventHandler) {
        if (eventHandler.uniqueID) {
            delete this._eventHandlers[eventHandler.uniqueID.toString(16)];
        }
    }
}
exports.Event = Event;
exports.default = Event;
