"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("../../package");
const Environment_1 = require("../Runtime/Environment");
const SystemException_1 = require("./SystemException");
const Type_1 = require("../Type");
class ArgumentException extends SystemException_1.default {
    constructor(paramName, message, innerException) {
        super(message, innerException);
        this._paramName = (paramName || null);
    }
    get message() {
        if (this.paramName === null) {
            return super.message;
        }
        else {
            return super.message + Environment_1.default.NEWLINE + 'The value for \'' + this.paramName + '\' is invalid.';
        }
    }
    get paramName() {
        return this._paramName;
    }
    getType() {
        return new Type_1.default(this, package_1.default);
    }
}
exports.ArgumentException = ArgumentException;
exports.default = ArgumentException;
