"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("../../package");
const ArgumentException_1 = require("./ArgumentException");
const Environment_1 = require("../Runtime/Environment");
const Type_1 = require("../Type");
class ArgumentOutOfRangeException extends ArgumentException_1.default {
    constructor(paramName, actualValue, message, innerException) {
        super(message, paramName, innerException);
        this._actualValue = (actualValue || null);
    }
    get message() {
        if (this.actualValue === null) {
            return super.message;
        }
        else {
            return super.message + Environment_1.default.NEWLINE + 'The actual value is \'' + this.actualValue + '\' .';
        }
    }
    get actualValue() {
        return this._actualValue;
    }
    getType() {
        return new Type_1.default(this, package_1.default);
    }
}
exports.ArgumentOutOfRangeException = ArgumentOutOfRangeException;
exports.default = ArgumentOutOfRangeException;
