"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("../package");
const Environment_1 = require("./Runtime/Environment");
const RuntimeUtility_1 = require("./Runtime/RuntimeUtility");
const _1 = require("./");
class _Object_ extends Environment_1.default.ESOBJECT {
    constructor() {
        super(...arguments);
        this._hashCode_ = undefined;
    }
    equals(other) {
        return (other != null
            && other.getHashCode() === this.getHashCode()
            && other.getType().equals(this.getType())
            && other.valueOf() === this.valueOf());
    }
    getHashCode() {
        if (this._hashCode_ === undefined) {
            this._hashCode_ = RuntimeUtility_1.default.generateUniqueHashCode();
        }
        return this._hashCode_;
    }
    getType() {
        return new _1.Type(this, package_1.default);
    }
    toString() {
        return this.getType().toString();
    }
    valueOf() {
        return this.getHashCode();
    }
}
exports.default = _Object_;
