/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
import Type from '../Type';
import ValueType from './ValueType';
/**
 *
 * @extends ValueType
 */
export declare class Boolean extends ValueType<boolean> {
    static readonly FALSE: Boolean;
    static readonly TRUE: Boolean;
    /**
     * Initialize the boolean with a provided primitive value.
     * @param {boolean|ValueType} value The primitive value of this boolean.
     */
    constructor(value?: (boolean | ValueType<boolean>));
    /**
     * Filters the boolean value at initialization.
     * @param {boolean|ValueType|undefined} value The provided boolean value.
     * @return {boolean} The filtered boolean value.
     */
    protected filter(value: (boolean | ValueType<boolean> | undefined)): boolean;
    /**
     * Returns the type of this boolean for further reflection.
     * @return {Type} The type of this boolean.
     */
    getType(): Type;
}
export default Boolean;
