"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("../../package");
const Type_1 = require("../Type");
const ValueType_1 = require("./ValueType");
class Boolean extends ValueType_1.default {
    constructor(value) {
        super(value);
        if (value === undefined) {
            value = false;
        }
        if (value instanceof ValueType_1.default) {
            value = value.valueOf();
        }
        if (value === false
            && Boolean.FALSE instanceof Boolean) {
            return Boolean.FALSE;
        }
        else if (value === true
            && Boolean.TRUE instanceof Boolean) {
            return Boolean.TRUE;
        }
    }
    filter(value) {
        return (value ? value.valueOf() : false);
    }
    getType() {
        return new Type_1.default(this, package_1.default);
    }
}
Boolean.FALSE = new Boolean(false);
Boolean.TRUE = new Boolean(true);
exports.Boolean = Boolean;
exports.default = Boolean;
