"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const Environment_1 = require("../Runtime/Environment");
const ValueType_1 = require("./ValueType");
class Enum extends ValueType_1.default {
    constructor(name, value) {
        super(value);
        this._name = name;
    }
    equals(other) {
        return (other instanceof Enum
            && other._name === this._name
            && super.equals(other));
    }
    filter(value) {
        if (value === undefined) {
            return Environment_1.default.ESOBJECT.keys(this.constructor).length;
        }
        if (value instanceof ValueType_1.default) {
            value = value.valueOf();
        }
        return value;
    }
    toString() {
        return this._name;
    }
}
exports.Enum = Enum;
exports.default = Enum;
