/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
import Type from '../Type';
import ValueType from './ValueType';
/**
 * Represents 32 bit integer.
 * @extends ValueType
 */
export declare class Int32 extends ValueType<number> {
    static readonly MAX_VALUE: Int32;
    static readonly MIN_VALUE: Int32;
    static readonly MINUS: Int32;
    static readonly NULL: Int32;
    /**
     * Filters the number value at initialization.
     * @param {number|ValueType|undefined} value The provided number value.
     * @return {number} The filtered number value.
     */
    protected filter(value: (number | ValueType<number> | undefined)): number;
    /**
     * Returns the type of the integer for further reflection.
     * @return {Type} Returns the type of this integer.
     */
    getType(): Type;
}
export default Int32;
