"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("../../package");
const Type_1 = require("../Type");
const ValueType_1 = require("./ValueType");
class Int32 extends ValueType_1.default {
    filter(value) {
        if (value === undefined) {
            return 0;
        }
        if (value instanceof ValueType_1.default) {
            value = value.valueOf();
        }
        if (value < 0) {
            return (value & 0xFFFFFFFF);
        }
        else {
            return (value & 0x7FFFFFFF);
        }
    }
    getType() {
        return new Type_1.default(this, package_1.default);
    }
}
Int32.MAX_VALUE = new Int32(0x7FFFFFFF);
Int32.MIN_VALUE = new Int32(0xFFFFFFFF);
Int32.MINUS = new Int32();
Int32.NULL = new Int32();
exports.Int32 = Int32;
exports.default = Int32;
