/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
import Enum from './Enum';
import Type from '../Type';
/**
 * Provides the type of basic objects.
 * @extends Enum
 */
export declare class TypeCodes extends Enum {
    /**
     * The null type representing the null reference.
     */
    static readonly EMPTY: TypeCodes;
    /**
     * The boolean type representing boolean based value types.
     */
    static readonly BOOLEAN: TypeCodes;
    /**
     * The number type representing number based value types.
     */
    static readonly NUMBER: TypeCodes;
    /**
     * The string type representing string based value types.
     */
    static readonly STRING: TypeCodes;
    /**
     * Returns the type of the enum for further reflection.
     * @return {Type} Returns the type of this enum.
     */
    getType(): Type;
}
export default TypeCodes;
