"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
const Object_1 = require("../Object");
const RuntimeUtility_1 = require("../Runtime/RuntimeUtility");
class ValueType extends Object_1.default {
    constructor(value) {
        super();
        this._value = this.filter(value);
    }
    equals(other) {
        return (other instanceof ValueType
            && other.valueOf() == this.valueOf()
            && other.getType().equals(this.getType()));
    }
    getHashCode() {
        if (this._hashCode === undefined) {
            let value = this.valueOf();
            switch (typeof value) {
                case 'boolean':
                    this._hashCode = (value === true ? 1 : 0);
                    break;
                case 'number':
                    this._hashCode = value;
                    break;
                default:
                    this._hashCode = RuntimeUtility_1.default.generateStringHashCode(value);
                    break;
            }
        }
        return this._hashCode;
    }
    toString() {
        return this.valueOf().toString();
    }
    valueOf() {
        return this._value;
    }
}
exports.ValueType = ValueType;
exports.default = ValueType;
