/// <reference types="node" />
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
/**
 * Provides information and functions for the current process and runtime.
 */
export declare module Environment {
    /**
     * The global base object at runtime.
     */
    const ESOBJECT: typeof Object;
    /**
     * The global string object at runtime.
     */
    const ESSTRING: typeof String;
    /**
     * The newline string for this environment.
     */
    const NEWLINE: string;
    /**
     * Every newline string of possible environments.
     */
    const NEWLINE_ALL: string[];
    /**
     * The global root scope at runtime.
     */
    const ROOT: (Window | NodeJS.Global);
    /**
     * Terminates the current process and returns an exit code to the runtime.
     * @param {number|Int32} exitCode The exit code for the runtime.
     * @exception {Error} Insufficient security permission to exit.
     */
    function exit(exitCode?: number): void;
}
export default Environment;
