"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
var Environment;
(function (Environment) {
    Environment.ESOBJECT = Object;
    Environment.ESSTRING = String;
    Environment.NEWLINE = '\n';
    Environment.NEWLINE_ALL = ['\n', '\r', '\r\n'];
    Environment.ROOT = (window !== undefined ? window : global !== undefined ? global : self);
    function exit(exitCode = 0) {
        let root = Environment.ROOT;
        if (root.process) {
            root.process.exit(exitCode);
        }
        else if (root.close) {
            root.close();
        }
        else {
            throw new Error('The caller does not have sufficient security permission to perform a process exit.');
        }
    }
    Environment.exit = exit;
})(Environment = exports.Environment || (exports.Environment = {}));
exports.default = Environment;
