"use strict";
/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  System Core TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License; you may not use this file except in
  compliance with the License. You may obtain a copy of the MIT License at
  https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
Object.defineProperty(exports, "__esModule", { value: true });
var RuntimeUtility;
(function (RuntimeUtility) {
    RuntimeUtility.MAX_SAFE_INTEGER = 0x1FFFFFFFFFFFFF;
    RuntimeUtility.MIN_SAFE_INTEGER = -0x1FFFFFFFFFFFFF;
    let generatedStringHashCodeSalt = (1 + (Math.random() * (RuntimeUtility.MAX_SAFE_INTEGER - 1)));
    let generatedUniqueHashCodeCounter = RuntimeUtility.MIN_SAFE_INTEGER;
    function generateStringHashCode(str) {
        let hash1 = 5381;
        let hash2 = hash1;
        let len = str.length;
        while (len > 2) {
            hash1 = ((hash1 << 5) + hash1 + (hash1 >> 27)) ^ str.charCodeAt(len - 1);
            hash2 = ((hash2 << 5) + hash2 + (hash2 >> 27)) ^ str.charCodeAt(len - 2);
            len -= 2;
        }
        if (len > 0) {
            hash1 = ((hash1 << 5) + hash1 + (hash1 >> 27)) ^ str.charCodeAt(len - 1);
        }
        hash1 ^= generatedStringHashCodeSalt;
        return (hash1 + (hash2 * 1566083941));
    }
    RuntimeUtility.generateStringHashCode = generateStringHashCode;
    function generateUniqueHashCode() {
        return ++generatedUniqueHashCodeCounter;
    }
    RuntimeUtility.generateUniqueHashCode = generateUniqueHashCode;
})(RuntimeUtility = exports.RuntimeUtility || (exports.RuntimeUtility = {}));
exports.default = RuntimeUtility;
